module clipper_8bit (in, ctl, out);
	input [7:0] in;
	input [2:0] ctl;
	output [7:0] out;
	
	wire force_1, force_0, not_ctl2;
	
	IN1 inst_not_in2 (.A(ctl[2]), .Q(not_ctl2));
	
	// force_1
	OA21 inst_force1 (.A(ctl[0]), .B(ctl[1]), .C(not_ctl2), .Q(force_1));
	// force_0
	AO21 inst_force0 (.A(ctl[0]), .B(ctl[1]), .C(not_ctl2), .Q(force_0));
	
	//bit_7
	OA21 inst_out7 (.A(force_1), .B(in[7]), .C(force_0), .Q(out[7]));
	//bit_6
	OA21 inst_out6 (.A(force_1), .B(in[6]), .C(force_0), .Q(out[6]));
	//bit_5
	OA21 inst_out5 (.A(force_1), .B(in[5]), .C(force_0), .Q(out[5]));
	//bit_4
	OA21 inst_out4 (.A(force_1), .B(in[4]), .C(force_0), .Q(out[4]));
	//bit_3
	OA21 inst_out3 (.A(force_1), .B(in[3]), .C(force_0), .Q(out[3]));
	//bit_2
	OA21 inst_out2 (.A(force_1), .B(in[2]), .C(force_0), .Q(out[2]));
	//bit_1
	OA21 inst_out1 (.A(force_1), .B(in[1]), .C(force_0), .Q(out[1]));
	//bit_0
	OA21 inst_out0 (.A(force_1), .B(in[0]), .C(force_0), .Q(out[0]));
	
endmodule
	
	
 
