// Single-rail full adder implemented in negative logic gates
module fa1b (A, B, Ci, S, Co);
  input A, B, Ci; // A,B - input bits; Ci - input carry
  output S, Co; // S - sum; Co - output carry
  wire ab_na, ab_no, ab_nai, ab_xor, t, p, q;

  NA2 g1(A, B, ab_na);
  NO2 g2(A, B, ab_no);
  IN1 g3(ab_na, ab_nai);
  NO2 g4(ab_nai, ab_no, ab_xor);
  NO2 g5(ab_xor, Ci, p);
  NA2 g6(ab_xor, Ci, t);
  IN1 g7(t, q);
  NO2 g8(p, q, S);
  NA2 g9(ab_na, t, Co);
endmodule
